﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xenon.KifuNarabe.L01_Communication;

namespace Xenon.KifuNarabe.L02_Common
{

    /// <summary>
    /// ************************************************************************************************************************
    /// 局面の持ち方を、ここに書きます。
    /// ************************************************************************************************************************
    /// </summary>
    public class Kyokumen
    {

        #region プロパティ類
        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// [0]～[39]の40個の駒。
        /// 添え字の数字をハンドルと呼び、ハンドルを駒の代わりのように使います。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        public TeProcess[] KomaDoors;

        #endregion


        /// <summary>
        /// ************************************************************************************************************************
        /// コンストラクターです。
        /// ************************************************************************************************************************
        /// </summary>
        public Kyokumen()
        {
            Okiba okiba = Okiba.ShogiBan;
            int suji = TeProcess.CTRL_NOTHING_PROPERTY_SUJI;
            int dan = TeProcess.CTRL_NOTHING_PROPERTY_DAN;

            this.KomaDoors = new TeProcess[]{
                // 先手
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Hisya),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kaku),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kyo),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kei),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Gin),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kin),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Oh),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kin),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Gin),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kei),
                new TeProcess(Sengo.Sente,okiba,suji,dan, KomaSyurui.Kyo),

                // 後手
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Fu),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Hisya),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kaku),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kyo),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kei),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Gin),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kin),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Oh),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kin),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Gin),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kei),
                new TeProcess(Sengo.Gote,okiba,suji,dan, KomaSyurui.Kyo),
            };
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 指定の場所にある駒を返します。
        /// ************************************************************************************************************************
        /// 
        ///         置き場は指定できますが、先後は見ません。
        /// 
        /// </summary>
        /// <param name="okiba">置き場</param>
        /// <param name="masu">筋、段</param>
        /// <param name="uc_Main">メインパネル</param>
        /// <returns>駒。無ければヌル。</returns>
        public int HKoma_AtMasuDokodemo(Okiba okiba, TeProcess masu)
        {
            int hFound = -1;

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                // 置き場は指定できますが、先後は見ません。
                if (koma.Okiba == okiba
                    && koma.Suji == masu.Suji
                    && koma.Dan == masu.Dan)
                {
                    hFound = i;
                    break;
                }
            }

            return hFound;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 指定の場所にある駒を返します。
        /// ************************************************************************************************************************
        /// 
        ///         先後は見ますが、将棋盤限定です。
        /// 
        /// </summary>
        /// <param name="okiba">置き場</param>
        /// <param name="masu">筋、段</param>
        /// <param name="uc_Main">メインパネル</param>
        /// <returns>駒。無ければヌル。</returns>
        public int HKoma_AtMasu_Shogiban(Sengo sengo, TeProcess masu)
        {
            int foundKoma = -1;

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                // 先後は見ますが、将棋盤限定です。
                if (
                    koma.Sengo == sengo
                    && koma.Okiba == Okiba.ShogiBan
                    && koma.Suji == masu.Suji
                    && koma.Dan == masu.Dan)
                {
                    foundKoma = i;
                    break;
                }
            }

            return foundKoma;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 軌道上の駒たち
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="km"></param>
        /// <returns></returns>
        public List<int> KomaHandles_EachSrc(Sengo sengo, TeProcess itaru, List<TeProcess> srcList)
        {
            List<int> komaHandleList = new List<int>();
            foreach (TeProcess src in srcList)
            {
                int hKoma = this.HKoma_AtMasu_Shogiban(sengo, src);
                if (0 <= hKoma)
                {
                    // 指定の升に駒がありました。
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                    komaHandleList.Add(hKoma);
                }
            }

            return komaHandleList;
        }


        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドルを返します。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="okiba"></param>
        /// <param name="kifu"></param>
        /// <returns></returns>
        public List<int> HKomas_ByOkibaSengo(Okiba okiba, Sengo sengo)
        {
            List<int> hKomas = new List<int>();

            for (int h = 0; h < this.KomaDoors.Length; h++)
            {
                TeProcess koma = this.KomaDoors[h];

                if (
                    okiba == koma.Okiba
                    && sengo == koma.Sengo
                    )
                {
                    hKomas.Add(h);
                }
            }

            return hKomas;
        }



        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドルを返します。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="okiba"></param>
        /// <param name="kifu"></param>
        /// <returns></returns>
        public List<int> HKomas_ByOkiba(Okiba okiba)
        {
            List<int> hKomas = new List<int>();

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                if (okiba == koma.Okiba)
                {
                    hKomas.Add(i);
                }
            }

            return hKomas;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドルを返します。　：　置き場、種類
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="okiba"></param>
        /// <param name="syurui"></param>
        /// <param name="kifu"></param>
        /// <returns></returns>
        public List<int> HKomas_ByOkibaSyurui(Okiba okiba, KomaSyurui syurui)
        {
            List<int> hKomas = new List<int>();

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                if (
                    okiba == koma.Okiba
                    && syurui == koma.Syurui
                    )
                {
                    hKomas.Add(i);
                }
            }

            return hKomas;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドルを返します。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="okiba"></param>
        /// <param name="sengo"></param>
        /// <param name="syurui"></param>
        /// <param name="kifu"></param>
        /// <returns></returns>
        public List<int> HKomas_ByOkibaSengoSyurui(Okiba okiba, Sengo sengo, KomaSyurui syurui)
        {
            List<int> hKomas = new List<int>();

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                if (
                    okiba == koma.Okiba
                    && sengo == koma.Sengo
                    && syurui == koma.Syurui
                    )
                {
                    hKomas.Add(i);
                }
            }

            return hKomas;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドルを返します。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="sengo"></param>
        /// <param name="hKomas"></param>
        /// <returns></returns>
        public List<int> HKomas_BySengo(Sengo sengo)
        {
            List<int> hKomas = new List<int>();

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                if (
                    sengo == koma.Sengo
                    )
                {
                    hKomas.Add(i);
                }
            }

            return hKomas;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドル(*1)を返します。
        /// ************************************************************************************************************************
        /// 
        ///         *1…将棋の駒１つ１つに付けられた番号です。
        /// 
        /// </summary>
        /// <param name="syurui"></param>
        /// <param name="hKomas"></param>
        /// <returns></returns>
        public List<int> HKomas_BySyurui(KomaSyurui syurui)
        {
            List<int> hKomas = new List<int>();

            for (int i = 0; i < this.KomaDoors.Length; i++)
            {
                TeProcess koma = this.KomaDoors[i];

                if (
                    syurui == koma.Syurui
                    )
                {
                    hKomas.Add(i);
                }
            }

            return hKomas;
        }


        /// <summary>
        /// ************************************************************************************************************************
        /// 駒の種類（不成として扱います）を指定して、駒を検索します。無ければヌル。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="okiba"></param>
        /// <param name="syurui"></param>
        /// <param name="uc_Main"></param>
        /// <returns></returns>
        public int HKoma_BySyuruiIgnoreCase(Okiba okiba, KomaSyurui syurui)
        {
            int found = -1;

            KomaSyurui syuruiFunariCase = Converter01.SyuruiToFunariCase(syurui);

            for (int i = 0; i < this.KomaDoors.Length; i++ )
            {
                TeProcess koma = this.KomaDoors[i];

                if (koma.Okiba == okiba
                    && koma.ToFunariCase() == syuruiFunariCase)
                {
                    found = i;
                    break;
                }
            }

            return found;
        }



        /// <summary>
        /// ************************************************************************************************************************
        /// 駒を駒袋に移動させます。
        /// ************************************************************************************************************************
        /// 
        /// 駒袋には、不成にして入れておきます。
        /// </summary>
        public void ClearToKomabukuro()
        {
            System.Console.WriteLine("全駒 this.KomaDoors.Length=" + this.KomaDoors.Length);

            for (int h = 0; h < this.KomaDoors.Length; h++)
            {
                TeProcess koma = this.KomaDoors[h];

                this.KomaDoors[h] = new TeProcess(
                    koma.Sengo,
                    Okiba.KomaBukuro,
                    TeProcess.CTRL_NOTHING_PROPERTY_SUJI,
                    TeProcess.CTRL_NOTHING_PROPERTY_DAN,
                    Converter01.SyuruiToFunariCase(koma.Syurui)
                    );

                System.Console.WriteLine("　　koma.ToText()=" + koma.ToSfenText());
            }
        }

    }
}
