﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xenon.KifuNarabe.L01_Communication;
using Xenon.KifuNarabe.L04_Shape;

namespace Xenon.KifuNarabe.L06_Ui
{

    /// <summary>
    /// ************************************************************************************************************************
    /// あるデータを、別のデータに変換します。
    /// ************************************************************************************************************************
    /// </summary>
    public abstract class Converter06
    {

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドル(*1)を元に、ボタンを返します。
        /// ************************************************************************************************************************
        /// 
        ///     *1…将棋の駒１つ１つに付けられた番号です。
        /// 
        /// </summary>
        /// <param name="hKomas"></param>
        /// <param name="brush_PnlTaikyoku"></param>
        /// <returns></returns>
        public static List<Shape_BtnKoma> HKomasToBtns(List<int> hKomas, Shape_PnlTaikyoku brush_PnlTaikyoku)
        {
            List<Shape_BtnKoma> btns = new List<Shape_BtnKoma>();

            foreach (int handle in hKomas)
            {
                Shape_BtnKoma btn = brush_PnlTaikyoku.BtnKomaDoors[handle];
                if (null != btn)
                {
                    btns.Add(btn);
                }
            }

            return btns;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒のハンドル(*1)を元に、ボタンを返します。
        /// ************************************************************************************************************************
        /// 
        ///     *1…将棋の駒１つ１つに付けられた番号です。
        /// 
        /// </summary>
        /// <param name="hKoma"></param>
        /// <param name="brush_PnlTaikyoku"></param>
        /// <returns></returns>
        public static Shape_BtnKoma HKomaToBtn(int hKoma, Shape_PnlTaikyoku brush_PnlTaikyoku)
        {
            Shape_BtnKoma found = null;

            if (0 <= hKoma && hKoma < brush_PnlTaikyoku.BtnKomaDoors.Length)
            {
                found = brush_PnlTaikyoku.BtnKomaDoors[hKoma];
            }

            return found;
        }
    }
}
