﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Xenon.KifuNarabe.L06_Ui
{

    /// <summary>
    /// ************************************************************************************************************************
    /// このメインパネルに、何かして欲しいという要求は、ここに入れられます。
    /// ************************************************************************************************************************
    /// </summary>
    public class RequestForMain
    {

        #region プロパティ類
        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 入力欄のテキストを上書きしたいときに設定(*1)します。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 
        ///         *1…ヌルなら、要求フラグは偽になります。
        /// </summary>
        public string RequestInputTextString
        {
            get
            {
                return this.requestInputTextString;
            }
            set
            {
                string str = value;

                if (null == str)
                {
                    this.canInputTextFlag = false;
                }
                else
                {
                    this.canInputTextFlag = true;
                }

                this.requestInputTextString = value;
            }
        }
        private string requestInputTextString;

        /// <summary>
        /// フラグ。読取専用。
        /// </summary>
        public bool CanInputTextFlag
        {
            get
            {
                return this.canInputTextFlag;
            }
        }
        private bool canInputTextFlag;

        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 入力欄の後ろにテキストを付け足したいときに設定(*1)します。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 
        ///         *1…ヌルなら、要求フラグは偽になります。
        /// 
        /// </summary>
        public string RequestAppendInputTextString
        {
            get
            {
                return this.requestAppendInputTextString;
            }
            set
            {
                string str = value;

                if(null==str)
                {
                    this.canAppendInputTextFlag = false;
                }
                else
                {
                    this.canAppendInputTextFlag = true;
                }

                this.requestAppendInputTextString = str;
            }
        }
        private string requestAppendInputTextString;

        /// <summary>
        /// フラグ。読取専用。
        /// </summary>
        public bool CanAppendInputTextFlag
        {
            get
            {
                return canAppendInputTextFlag;
            }
        }
        private bool canAppendInputTextFlag;


        /// <summary>
        ///------------------------------------------------------------------------------------------------------------------------
        /// 出力欄をクリアーしたいときは、真にしてください。
        ///------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        public bool RequestClearTxtOutput
        {
            get;
            set;
        }

        /// <summary>
        ///------------------------------------------------------------------------------------------------------------------------
        /// 出力欄に棋譜を出力したいときは、真にしてください。
        ///------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        public bool RequestOutputKifu
        {
            get;
            set;
        }

        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 出力欄にHTMLを出力したいときは、真にしてください。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        public bool RequestOutputHtml
        {
            get;
            set;
        }

        /// <summary>
        ///------------------------------------------------------------------------------------------------------------------------
        /// メインパネルを再描画したいときは、真にしてください。
        ///------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        public bool RequestRefresh
        {
            get;
            set;
        }

        #endregion


        /// <summary>
        /// ************************************************************************************************************************
        /// コンストラクタです。
        /// ************************************************************************************************************************
        /// </summary>
        public RequestForMain()
        {
        }

    }


}
