﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Drawing;
using System.Windows.Forms;
using Xenon.KifuNarabe.L00_DammyConsole;
using Xenon.KifuNarabe.L01_Communication;
using Xenon.KifuNarabe.L02_Common;
using Xenon.KifuNarabe.L03_TuginoItte;
using Xenon.KifuNarabe.L04_Shape;
using Xenon.KifuNarabe.L05_Server;

namespace Xenon.KifuNarabe.L06_Ui
{



    /// <summary>
    /// ************************************************************************************************************************
    /// 画面を操作したときの挙動は、まず、ここに入れます。
    /// ************************************************************************************************************************
    /// </summary>
    public abstract class Ui_01EventDetail
    {

        /// <summary>
        /// ************************************************************************************************************************
        /// マウスのボタンを押下したときの反応や、将棋データの変更は、ここに書きます。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="ui_PnlMain"></param>
        /// <param name="requestForMain"></param>
        /// <param name="e"></param>
        /// <param name="brush_PnlTaikyoku"></param>
        /// <param name="kifu"></param>
        public static void Ui_PnlMain_MouseDownDetail(
            Ui_PnlMain ui_PnlMain,
            ref RequestForMain requestForMain,
            MouseEventArgs e, Shape_PnlTaikyoku brush_PnlTaikyoku, Kifu kifu)
        {
            if (e.Button == MouseButtons.Left)
            {
                //------------------------------------------------------------
                // 左ボタン
                //------------------------------------------------------------


                //----------
                // 既に選択されている駒
                //----------
                Shape_BtnKoma btnKoma_Selected = brush_PnlTaikyoku.Btn_Selected();


                //----------
                // 将棋盤：升目   ＜移動先など＞
                //----------
                if (null != btnKoma_Selected)
                {
                    // 選択されている駒があるとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (Shape_BtnMasu btnMasu in brush_PnlTaikyoku.Shogiban.MasuList)
                    {
                        if (btnMasu.HitByMouse(e.Location.X, e.Location.Y))
                        {
                            // どこかの升目をクリックしたとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Ui_01EventDetail.Ui_PnlMain_MouseDownDetailSub_Komamove1BtnMasu(btnKoma_Selected, btnMasu, brush_PnlTaikyoku, kifu);

                            requestForMain.RequestRefresh = true;
                        }
                    }
                }

                //----------
                // 駒置き：升目
                //----------
                if (null != btnKoma_Selected)
                {
                    // 選択されている駒があるとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (Shape_PnlKomadai komaoki in brush_PnlTaikyoku.KomadaiArr)
                    {
                        foreach (Shape_BtnMasu btnMasu in komaoki.MasuList)
                        {
                            if (btnMasu.HitByMouse(e.Location.X, e.Location.Y))
                            {
                                // 升目をクリックしたとき
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                Okiba okiba;
                                switch (komaoki.Sengo)
                                {
                                    case Sengo.Gote:
                                        okiba = Okiba.Gote_Komadai;
                                        break;
                                    default:
                                        okiba = Okiba.Sente_Komadai;
                                        break;
                                }

                                kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle] = new TeProcess(
                                    komaoki.Sengo,// 先手の駒置きに駒を置けば、先手の向きに揃えます。
                                    okiba,
                                    btnMasu.Masu.Suji,
                                    btnMasu.Masu.Dan,
                                    Converter01.SyuruiToFunariCase(kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Syurui)//成りは解除。
                                );



                                Ui_03Action.Refresh_KomaLocation(btnKoma_Selected.Handle, brush_PnlTaikyoku, kifu.Kyokumen);
                                requestForMain.RequestRefresh = true;
                            }
                        }
                    }
                }

                //----------
                // 駒
                //----------
                foreach (Shape_BtnKoma btnKoma in brush_PnlTaikyoku.BtnKomaDoors)
                {
                    btnKoma.SelectByMouse(e.Location.X, e.Location.Y);
                    if (btnKoma.Selected)
                    {
                        // 新たに選択された駒があります
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        if (null == btnKoma_Selected)
                        {
                            // 掴みたい駒の上でマウスダウンしました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                            brush_PnlTaikyoku.SetMouseProcessOrNull(new TeProcess(
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Sengo,
                                Okiba.CTRL_NOTHING_PROPERTY,
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Okiba,
                                TeProcess.CTRL_NOTHING_PROPERTY_SUJI,
                                TeProcess.CTRL_NOTHING_PROPERTY_DAN,
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Suji,
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Dan,
                                KomaSyurui.CTRL_NOTHING_PROPERTY,
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Syurui,
                                KomaSyurui.CTRL_NOTHING_PROPERTY
                                ));
                        }
                        else
                        {
                            // 掴んだ駒を置く先をマウスダウンしました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                            brush_PnlTaikyoku.SetMouseProcessOrNull(new TeProcess(
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Sengo,
                                kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Okiba,
                                brush_PnlTaikyoku.MouseProcessOrNull.SrcOkiba,
                                TeProcess.CTRL_NOTHING_PROPERTY_SUJI,
                                TeProcess.CTRL_NOTHING_PROPERTY_DAN,
                                brush_PnlTaikyoku.MouseProcessOrNull.SrcSuji,
                                brush_PnlTaikyoku.MouseProcessOrNull.SrcDan,
                                KomaSyurui.CTRL_NOTHING_PROPERTY,
                                kifu.Kyokumen.KomaDoors[btnKoma.Handle].Syurui,
                                brush_PnlTaikyoku.MouseProcessOrNull.TottaKoma
                                ));
                        }


                        brush_PnlTaikyoku.ClearAllMoverdFlag();
                        requestForMain.RequestRefresh = true;
                    }

                }

                //----------
                // 成るボタン
                //----------
                {
                    if (brush_PnlTaikyoku.BtnNaru.HitByMouse(e.Location.X, e.Location.Y))
                    {
                        Shape_BtnKoma btnMovedKoma = brush_PnlTaikyoku.Btn_MovedKoma();

                        if (null != btnMovedKoma)
                        {
                            // 移動直後の駒があるとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Ui_02Menu.Nari_KifuLast(btnMovedKoma, brush_PnlTaikyoku, kifu);
                            Ui_03Action.Refresh_KomaLocation(btnMovedKoma.Handle, brush_PnlTaikyoku, kifu.Kyokumen);

                            requestForMain.RequestOutputKifu = true;
                            requestForMain.RequestRefresh = true;
                        }
                        else if (null != btnKoma_Selected)
                        {
                            // 選択されている駒があるとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Ui_02Menu.Nari_KifuLast(btnKoma_Selected, brush_PnlTaikyoku, kifu);
                            Ui_03Action.Refresh_KomaLocation(btnKoma_Selected.Handle, brush_PnlTaikyoku, kifu.Kyokumen);

                            requestForMain.RequestOutputKifu = true;
                            requestForMain.RequestRefresh = true;
                        }
                    }
                }

                //----------
                // 向きボタン
                //----------

                if (brush_PnlTaikyoku.BtnMuki.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Shape_BtnKoma movedKoma = brush_PnlTaikyoku.Btn_MovedKoma();

                    if (null != movedKoma)
                    {
                        // 移動直後の駒があるとき
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        // TODO:棋譜に反映させたい。

                        switch (kifu.Kyokumen.KomaDoors[movedKoma.Handle].Sengo)
                        {
                            case Sengo.Sente:
                                kifu.Kyokumen.KomaDoors[movedKoma.Handle] = new TeProcess(
                                    Sengo.Gote,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Okiba,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Suji,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Dan,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Syurui
                                    );
                                break;

                            case Sengo.Gote:
                                kifu.Kyokumen.KomaDoors[movedKoma.Handle] = new TeProcess(
                                    Sengo.Sente,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Okiba,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Suji,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Dan,
                                    kifu.Kyokumen.KomaDoors[movedKoma.Handle].Syurui
                                    );
                                break;
                        }

                        requestForMain.RequestRefresh = true;
                    }
                    else if (null != btnKoma_Selected)
                    {
                        // 選択されている駒があるとき
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        switch (kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Sengo)
                        {
                            case Sengo.Sente:
                                kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle] = new TeProcess(
                                    Sengo.Gote,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Okiba,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Suji,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Dan,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Syurui
                                    );
                                break;

                            case Sengo.Gote:
                                kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle] = new TeProcess(
                                    Sengo.Sente,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Okiba,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Suji,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Dan,
                                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Syurui
                                    );
                                break;
                        }

                        requestForMain.RequestRefresh = true;
                    }
                }


                //----------
                // 初期配置ボタン
                //----------
                if (brush_PnlTaikyoku.BtnSyokihaichi.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Ui_03Action.Syokihaichi_Hirate( kifu);
                    // 再描画
                    foreach (Shape_BtnKoma btnKoma in brush_PnlTaikyoku.BtnKomaDoors)
                    {
                        Ui_03Action.Refresh_KomaLocation(btnKoma.Handle, brush_PnlTaikyoku, kifu.Kyokumen);
                    }

                    requestForMain.RequestClearTxtOutput = true;
                    requestForMain.RequestRefresh = true;
                }

                //----------
                // クリアーボタン
                //----------
                if (brush_PnlTaikyoku.BtnClear.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Ui_02Menu.ClearKifu(kifu);
                    //------------------------------
                    // 再描画
                    //------------------------------
                    foreach (Shape_BtnKoma btnKoma in brush_PnlTaikyoku.BtnKomaDoors)
                    {
                        Ui_03Action.Refresh_KomaLocation(btnKoma.Handle, brush_PnlTaikyoku, kifu.Kyokumen);
                    }

                    requestForMain.RequestClearTxtOutput = true;
                    requestForMain.RequestRefresh = true;
                }

                //----------
                // HTMLボタン
                //----------
                if (brush_PnlTaikyoku.BtnHtml.HitByMouse(e.Location.X, e.Location.Y))
                {
                    //uc_Main.SetTxtOutput(Operation_Kifu.CreateHtml(brush_PnlTaikyoku, kifu.Kyokumen));
                    requestForMain.RequestOutputHtml = true;
                    requestForMain.RequestRefresh = true;
                }

                //----------
                // 再生ボタン
                //----------
                if (brush_PnlTaikyoku.BtnPlay.HitByMouse(e.Location.X, e.Location.Y))
                {
                    // 内部でループ
                    // ref requestOutputKifu, ref requestRefresh,
                    Ui_02MenuLoop.Saisei(ui_PnlMain, brush_PnlTaikyoku, kifu);
                    goto gt_EndMethod;
                }

                //----------
                // コマ送りボタン
                //----------
                if (brush_PnlTaikyoku.BtnForward.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Ui_02Menu.Komaokuri(ref requestForMain, brush_PnlTaikyoku, kifu);
                }

                //----------
                // 戻るボタン
                //----------
                if (brush_PnlTaikyoku.BtnBackward.HitByMouse(e.Location.X, e.Location.Y))
                {
                    string backedInputText;
                    Ui_02Menu.Modoru( brush_PnlTaikyoku, kifu, out backedInputText);

                    requestForMain.RequestInputTextString = backedInputText;
                    requestForMain.RequestOutputKifu = true;
                    requestForMain.RequestRefresh = true;
                }

                //----------
                // 将棋エンジン起動ボタン
                //----------
                if (brush_PnlTaikyoku.BtnShogiEngineKido.HitByMouse(e.Location.X, e.Location.Y))
                {
                    ShogiEngineService.StartShogiEngine();
                }

                //----------
                // [▲]～[打]符号ボタン
                //----------
                if (brush_PnlTaikyoku.BtnFugo_Sente.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "▲"; }
                if (brush_PnlTaikyoku.BtnFugo_Gote.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "△"; }
                if (brush_PnlTaikyoku.BtnFugo_1.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "１"; }
                if (brush_PnlTaikyoku.BtnFugo_2.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "２"; }
                if (brush_PnlTaikyoku.BtnFugo_3.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "３"; }
                if (brush_PnlTaikyoku.BtnFugo_4.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "４"; }
                if (brush_PnlTaikyoku.BtnFugo_5.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "５"; }
                if (brush_PnlTaikyoku.BtnFugo_6.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "６"; }
                if (brush_PnlTaikyoku.BtnFugo_7.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "７"; }
                if (brush_PnlTaikyoku.BtnFugo_8.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "８"; }
                if (brush_PnlTaikyoku.BtnFugo_9.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "９"; }
                if (brush_PnlTaikyoku.BtnFugo_Dou.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "同"; }
                if (brush_PnlTaikyoku.BtnFugo_Fu.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "歩"; }
                if (brush_PnlTaikyoku.BtnFugo_Hisya.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "飛"; }
                if (brush_PnlTaikyoku.BtnFugo_Kaku.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "角"; }
                if (brush_PnlTaikyoku.BtnFugo_Kyo.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "香"; }
                if (brush_PnlTaikyoku.BtnFugo_Kei.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "桂"; }
                if (brush_PnlTaikyoku.BtnFugo_Gin.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "銀"; }
                if (brush_PnlTaikyoku.BtnFugo_Kin.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "金"; }
                if (brush_PnlTaikyoku.BtnFugo_Oh.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "王"; }
                if (brush_PnlTaikyoku.BtnFugo_Gyoku.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "玉"; }
                if (brush_PnlTaikyoku.BtnFugo_Tokin.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "と"; }
                if (brush_PnlTaikyoku.BtnFugo_Narikyo.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "成香"; }
                if (brush_PnlTaikyoku.BtnFugo_Narikei.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "成桂"; }
                if (brush_PnlTaikyoku.BtnFugo_Narigin.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "成銀"; }
                if (brush_PnlTaikyoku.BtnFugo_Ryu.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "竜"; }
                if (brush_PnlTaikyoku.BtnFugo_Uma.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "馬"; }
                if (brush_PnlTaikyoku.BtnFugo_Yoru.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "寄"; }
                if (brush_PnlTaikyoku.BtnFugo_Hiku.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "引"; }
                if (brush_PnlTaikyoku.BtnFugo_Agaru.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "上"; }
                if (brush_PnlTaikyoku.BtnFugo_Migi.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "右"; }
                if (brush_PnlTaikyoku.BtnFugo_Hidari.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "左"; }
                if (brush_PnlTaikyoku.BtnFugo_Sugu.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "直"; }
                if (brush_PnlTaikyoku.BtnFugo_Nari.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "成"; }
                if (brush_PnlTaikyoku.BtnFugo_Funari.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "不成"; }
                if (brush_PnlTaikyoku.BtnFugo_Da.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestAppendInputTextString = "打"; }
                if (brush_PnlTaikyoku.BtnFugo_Zenkesi.HitByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestInputTextString = ""; }
                if (brush_PnlTaikyoku.BtnFugo_ComputernoSaizensyu.HitByMouse(e.Location.X, e.Location.Y)) {
                    // 最善手を入力欄１に足します。
                    requestForMain.RequestAppendInputTextString = DammyConsole.DefaultDammyConsole.ReadLine2();
                    // 反映させます。
                    ui_PnlMain.Response(requestForMain);
                    // コマ送りします。
                    Ui_02Menu.Komaokuri(ref requestForMain, brush_PnlTaikyoku, kifu);
                    // 反映させます。
                    ui_PnlMain.Response(requestForMain);
                    requestForMain = new RequestForMain();//クリアー
                }
                if (brush_PnlTaikyoku.BtnFugo_KokokaraSaifu.HitByMouse(e.Location.X, e.Location.Y))
                {
                    kifu.SetStartpos_KokokaraSaifu(kifu.Sengo);
                    requestForMain.RequestOutputKifu = true;
                }
            }
            else if (e.Button == MouseButtons.Right)
            {
                //------------------------------------------------------------
                // 右ボタン
                //------------------------------------------------------------
                brush_PnlTaikyoku.ClearAllSelectedFlag();
            }

        gt_EndMethod:
            ;
        }


        /// <summary>
        /// ************************************************************************************************************************
        /// マウスのボタンを放したときの反応や、将棋データの変更は、ここに書きます。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="requestOutputKifu"></param>
        /// <param name="requestRefresh"></param>
        /// <param name="e"></param>
        /// <param name="brush_PnlTaikyoku"></param>
        /// <param name="kifu"></param>
        public static void Ui_PnlMain_MouseUpDetail(ref RequestForMain requestForMain, MouseEventArgs e, Shape_PnlTaikyoku brush_PnlTaikyoku, Kifu kifu)
        {
            if (e.Button == MouseButtons.Left)
            {
                //------------------------------------------------------------
                // 左ボタン
                //------------------------------------------------------------


                //----------
                // 将棋盤：升目
                //----------
                foreach (Shape_BtnMasu cell in brush_PnlTaikyoku.Shogiban.MasuList)
                {
                    if (cell.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        requestForMain.RequestRefresh = true;
                    }
                }

                //----------
                // 駒置き：升目
                //----------
                foreach (Shape_PnlKomadai komaoki in brush_PnlTaikyoku.KomadaiArr)
                {
                    foreach (Shape_BtnMasu cell in komaoki.MasuList)
                    {
                        if (cell.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }
                }

                //----------
                // 駒
                //----------
                foreach (Shape_BtnKoma btnKoma in brush_PnlTaikyoku.BtnKomaDoors)
                {
                    if (btnKoma.HitByMouse(e.Location.X, e.Location.Y))
                    {
                        // マウスが重なっていました
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        if (btnKoma.Deselect())
                        {
                            // 動かした駒から、指を放しました
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            if (kifu.Kyokumen.KomaDoors[btnKoma.Handle].DoneMove())
                            {
                                // 駒の移動を、確定しました。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                Ui_01EventDetail.Ui_PnlMain_MouseUpDetailSub_Komamove2BtnKoma(btnKoma, brush_PnlTaikyoku, kifu);

                                requestForMain.RequestOutputKifu = true; //棋譜出力要求
                                requestForMain.RequestRefresh = true;
                            }
                        }
                    }
                }



                //------------------------------------------------------------
                // 選択解除か否か
                //------------------------------------------------------------
                {
                    //----------
                    // 成るボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnNaru.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // 向きボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnMuki.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // 初期配置ボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnSyokihaichi.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // クリアーボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnClear.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // HTMLボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnHtml.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // 再生ボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnPlay.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // コマ送りボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnForward.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // 戻るボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnBackward.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // 将棋エンジン起動ボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnShogiEngineKido.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            requestForMain.RequestRefresh = true;
                        }
                    }

                    //----------
                    // [▲]～[打]符号ボタン
                    //----------
                    {
                        if (brush_PnlTaikyoku.BtnFugo_Sente.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Gote.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_1.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_2.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_3.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_4.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_5.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_6.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_7.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_8.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_9.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Dou.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Fu.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Hisya.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Kaku.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Kyo.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Kei.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Gin.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Kin.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Oh.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Gyoku.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Tokin.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Narikyo.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Narikei.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Narigin.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Ryu.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Uma.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Yoru.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Hiku.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Agaru.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Migi.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Hidari.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Sugu.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Nari.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Funari.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Da.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_Zenkesi.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_ComputernoSaizensyu.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                        if (brush_PnlTaikyoku.BtnFugo_KokokaraSaifu.DeselectByMouse(e.Location.X, e.Location.Y)) { requestForMain.RequestRefresh = true; }
                    }
                }


            }
            else if (e.Button == MouseButtons.Right)
            {
                //------------------------------------------------------------
                // 右ボタン
                //------------------------------------------------------------
            }
        }


        /// <summary>
        /// ************************************************************************************************************************
        /// マウスが重なったときの、表示物の反応はここに書きます。
        /// ************************************************************************************************************************
        /// 
        /// ほとんどは、黄色い枠を付けるフラグを立てているだけのはずです。
        /// </summary>
        /// <param name="requestRefresh"></param>
        /// <param name="mouse"></param>
        /// <param name="brush_PnlTaikyoku"></param>
        public static void Ui_PnlMain_MouseMoveDetail(ref RequestForMain requestForMain, Point mouse, Shape_PnlTaikyoku brush_PnlTaikyoku)
        {
            //----------
            // 将棋盤：升目
            //----------
            foreach (Shape_BtnMasu cell in brush_PnlTaikyoku.Shogiban.MasuList)
            {
                cell.LightByMouse(mouse.X, mouse.Y);
                if (cell.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 駒置き：升目
            //----------
            foreach (Shape_PnlKomadai komaoki in brush_PnlTaikyoku.KomadaiArr)
            {
                foreach (Shape_BtnMasu cell in komaoki.MasuList)
                {
                    cell.LightByMouse(mouse.X, mouse.Y);
                    if (cell.Light)
                    {
                        requestForMain.RequestRefresh = true;
                    }
                }
            }

            //----------
            // 駒
            //----------
            foreach (Shape_BtnKoma koma in brush_PnlTaikyoku.BtnKomaDoors)
            {
                koma.LightByMouse(mouse.X, mouse.Y);
                if (koma.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 成るボタン
            //----------
            {
                brush_PnlTaikyoku.BtnNaru.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnNaru.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 向きボタン
            //----------
            {
                brush_PnlTaikyoku.BtnMuki.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnMuki.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 初期配置ボタン
            //----------
            {
                brush_PnlTaikyoku.BtnSyokihaichi.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnSyokihaichi.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // クリアーボタン
            //----------
            {
                brush_PnlTaikyoku.BtnClear.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnClear.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // HTMLボタン
            //----------
            {
                brush_PnlTaikyoku.BtnHtml.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnHtml.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 再生ボタン
            //----------
            {
                brush_PnlTaikyoku.BtnPlay.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnPlay.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // コマ送りボタン
            //----------
            {
                brush_PnlTaikyoku.BtnForward.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnForward.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 戻るボタン
            //----------
            {
                brush_PnlTaikyoku.BtnBackward.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnBackward.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // 将棋エンジン起動ボタン
            //----------
            {
                brush_PnlTaikyoku.BtnShogiEngineKido.LightByMouse(mouse.X, mouse.Y);
                if (brush_PnlTaikyoku.BtnShogiEngineKido.Light)
                {
                    requestForMain.RequestRefresh = true;
                }
            }

            //----------
            // [▲]符号ボタン
            //----------
            {
                brush_PnlTaikyoku.BtnFugo_Sente.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Sente.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Gote.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Gote.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_1.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_1.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_2.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_2.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_3.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_3.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_4.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_4.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_5.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_5.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_6.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_6.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_7.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_7.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_8.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_8.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_9.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_9.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Dou.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Dou.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Fu.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Fu.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Hisya.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Hisya.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Kaku.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Kaku.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Kyo.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Kyo.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Kei.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Kei.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Gin.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Gin.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Kin.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Kin.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Oh.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Oh.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Gyoku.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Gyoku.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Tokin.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Tokin.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Narikyo.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Narikyo.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Narikei.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Narikei.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Narigin.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Narigin.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Ryu.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Ryu.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Uma.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Uma.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Yoru.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Yoru.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Hiku.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Hiku.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Agaru.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Agaru.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Migi.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Migi.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Hidari.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Hidari.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Sugu.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Sugu.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Nari.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Nari.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Funari.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Funari.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Da.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Da.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_Zenkesi.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_Zenkesi.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_ComputernoSaizensyu.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_ComputernoSaizensyu.Light) { requestForMain.RequestRefresh = true; }
                brush_PnlTaikyoku.BtnFugo_KokokaraSaifu.LightByMouse(mouse.X, mouse.Y); if (brush_PnlTaikyoku.BtnFugo_KokokaraSaifu.Light) { requestForMain.RequestRefresh = true; }
            }
        }



        /// <summary>
        /// ************************************************************************************************************************
        /// 駒を動かします(2)。マウスボタンが放されたとき。
        /// ************************************************************************************************************************
        /// </summary>
        public static void Ui_PnlMain_MouseUpDetailSub_Komamove2BtnKoma(
            Shape_BtnKoma k,
            Shape_PnlTaikyoku brush_PnlTaikyoku,
            Kifu kifu
            )
        {
            //----------
            // 移動済表示
            //----------
            k.Moved = true;

            //------------------------------
            // 棋譜に符号を追加
            //------------------------------
            // 棋譜
            TeProcess process = new TeProcess(
                kifu.Sengo,
                kifu.Kyokumen.KomaDoors[k.Handle].Okiba,
                brush_PnlTaikyoku.MouseProcessOrNull.SrcOkiba,
                kifu.Kyokumen.KomaDoors[k.Handle].Suji,
                kifu.Kyokumen.KomaDoors[k.Handle].Dan,
                brush_PnlTaikyoku.MouseProcessOrNull.SrcSuji,
                brush_PnlTaikyoku.MouseProcessOrNull.SrcDan,
                kifu.Kyokumen.KomaDoors[k.Handle].Syurui,
                brush_PnlTaikyoku.MouseProcessOrNull.SrcSyurui,
                brush_PnlTaikyoku.MouseProcessOrNull.TottaKoma
                );// 選択している駒の元の場所と、移動先

            TeProcess previousProcess = kifu.Last; //符号の追加が行われる前に退避
            kifu.Add(process);


            //------------------------------
            // 符号表示
            //------------------------------
            Fugo fugo;
            fugo = TuginoItte_JapanFugo.GetText_FromData(process, kifu.Kyokumen);
            //Process previousProcess = kifu.Last; //符号の追加が行われる前に退避
            //Process previousProcess = kifu.LastPrevious; //符号の追加が行われる前に退避
            brush_PnlTaikyoku.SetFugo(fugo.ToText(true, process, previousProcess));



            System.Console.WriteLine("チェンジターン？");
            //------------------------------
            // チェンジターン
            //------------------------------
            TeProcess last = kifu.Last;
            kifu.ChangeTurn(last.Suji, last.Dan);

        }



        /// <summary>
        /// ************************************************************************************************************************
        /// 駒を動かします(1)。マウスボタンが押下されたとき。
        /// ************************************************************************************************************************
        /// </summary>
        public static void Ui_PnlMain_MouseDownDetailSub_Komamove1BtnMasu(
            Shape_BtnKoma btnKoma_Selected, Shape_BtnMasu btnMasu, Shape_PnlTaikyoku brush_PnlTaikyoku, Kifu kifu)
        {
            //------------------------------
            // 駒の移動
            //------------------------------
            System.Console.WriteLine("★kifu.Kyokumen.Komas[selectedBtnKoma.KomaPropertyIndex].Sengo=" + Converter01.SengoToStr(kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Sengo));
            System.Console.WriteLine("★btnMasu.Masu.Okiba=" + btnMasu.Masu.Okiba);
            System.Console.WriteLine("★btnMasu.Masu.Suji=" + btnMasu.Masu.Suji);
            System.Console.WriteLine("★btnMasu.Masu.Dan=" + btnMasu.Masu.Dan);
            System.Console.WriteLine("★kifu.MouseProcessOrNull.SrcSyurui=" + Converter01.SyuruiToFugo(brush_PnlTaikyoku.MouseProcessOrNull.SrcSyurui));

            KomaSyurui tottaKoma;
            TeProcess dst = new TeProcess(
                    kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle].Sengo,
                    btnMasu.Masu.Okiba,
                    btnMasu.Masu.Suji,
                    btnMasu.Masu.Dan,
                    brush_PnlTaikyoku.MouseProcessOrNull.SrcSyurui
                );

            System.Console.WriteLine("取れる駒はあるか？");
            //----------
            // 将棋盤上のその場所に駒はあるか
            //----------
            tottaKoma = KomaSyurui.CTRL_NOTHING_PROPERTY;
            Shape_BtnKoma btnKoma_Under = Converter06.HKomaToBtn(kifu.Kyokumen.HKoma_AtMasuDokodemo(
                Okiba.ShogiBan, dst), brush_PnlTaikyoku);//盤上
            if (null != btnKoma_Under)
            {
                // 駒があったとき
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                tottaKoma = kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Syurui;

                // その駒は、駒置き場に移動させます。
                TeProcess ukProcess;
                switch (dst.Sengo)//sengo
                {
                    case Sengo.Gote:

                        ukProcess = Ui_03Action.GetKomadaiSpace(Okiba.Gote_Komadai, brush_PnlTaikyoku, kifu.Kyokumen);
                        if (null != ukProcess)
                        {
                            // 駒台に空きスペースがありました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle] = new TeProcess(
                                Sengo.Gote,
                                Okiba.Gote_Komadai,//駒台へ
                                ukProcess.Suji,
                                ukProcess.Dan,
                                Converter01.SyuruiToFunariCase(kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Syurui) // 取った駒は非成へ
                                );
                        }
                        else
                        {
                            // エラー：　駒台に空きスペースがありませんでした。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle] = new TeProcess(
                                Sengo.Gote,
                                Okiba.Gote_Komadai,
                                TeProcess.CTRL_NOTHING_PROPERTY_SUJI,
                                TeProcess.CTRL_NOTHING_PROPERTY_DAN,
                                Converter01.SyuruiToFunariCase(kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Syurui) // 取った駒は非成へ
                                );
                        }

                        Ui_03Action.Refresh_KomaLocation(btnKoma_Under.Handle, brush_PnlTaikyoku, kifu.Kyokumen);
                        break;

                    case Sengo.Sente://thru
                    default:

                        ukProcess = Ui_03Action.GetKomadaiSpace(Okiba.Sente_Komadai, brush_PnlTaikyoku, kifu.Kyokumen);
                        if (null != ukProcess)
                        {
                            // 駒台に空きスペースがありました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle] = new TeProcess(
                                Sengo.Sente,
                                Okiba.Sente_Komadai,//駒台へ
                                ukProcess.Suji,
                                ukProcess.Dan,
                                Converter01.SyuruiToFunariCase(kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Syurui) // 取った駒は非成へ
                                );
                        }
                        else
                        {
                            // エラー：　駒台に空きスペースがありませんでした。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle] = new TeProcess(
                                Sengo.Sente,
                                Okiba.Sente_Komadai,
                                TeProcess.CTRL_NOTHING_PROPERTY_SUJI,
                                TeProcess.CTRL_NOTHING_PROPERTY_DAN,
                                Converter01.SyuruiToFunariCase(kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Syurui) // 取った駒は非成へ
                                );
                        }

                        Ui_03Action.Refresh_KomaLocation(btnKoma_Under.Handle, brush_PnlTaikyoku, kifu.Kyokumen);
                        break;
                }

                //------------------------------
                // 成りは解除。
                //------------------------------
                switch (kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Okiba)
                {
                    case Okiba.Sente_Komadai://thru
                    case Okiba.Gote_Komadai:
                        // 駒台へ移動しました
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        KomaSyurui syurui2 = kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].ToFunariCase();

                        kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle] = new TeProcess(
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Sengo,
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Okiba,
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Suji,
                            kifu.Kyokumen.KomaDoors[btnKoma_Under.Handle].Dan,
                            syurui2
                            );

                        break;
                }

                // 取った駒を一次記憶します。
                brush_PnlTaikyoku.SetMouseProcessOrNull(
                    new TeProcess(
                        brush_PnlTaikyoku.MouseProcessOrNull.Sengo,
                        brush_PnlTaikyoku.MouseProcessOrNull.Okiba,
                        brush_PnlTaikyoku.MouseProcessOrNull.SrcOkiba,
                        brush_PnlTaikyoku.MouseProcessOrNull.Suji,
                        brush_PnlTaikyoku.MouseProcessOrNull.Dan,
                        brush_PnlTaikyoku.MouseProcessOrNull.SrcSuji,
                        brush_PnlTaikyoku.MouseProcessOrNull.SrcDan,
                        brush_PnlTaikyoku.MouseProcessOrNull.Syurui,
                        brush_PnlTaikyoku.MouseProcessOrNull.SrcSyurui,
                        tottaKoma
                        )
                    );
            }

            System.Console.WriteLine("*駒移動");
            //------------------------------
            // 駒移動
            //------------------------------
            //
            //      選択している駒を、その場所に移動させます。
            //
            kifu.Kyokumen.KomaDoors[btnKoma_Selected.Handle] = dst;


            System.Console.WriteLine("再描画？");
            Ui_03Action.Refresh_KomaLocation(btnKoma_Selected.Handle, brush_PnlTaikyoku, kifu.Kyokumen);
        }

    }



}
